
#include <windows.h>  
#include "LodMenuI.h" 


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "My Application"; 

BOOL RegisterWin95( CONST WNDCLASS* lpwc );

int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   switch( uMsg )
   {
       case WM_CREATE :
               {
                  LPTSTR  lpMem;
                  WORD    wValue;
                  HMENU   hMenu;
 
                  lpMem = HeapAlloc( GetProcessHeap(), HEAP_ZERO_MEMORY, 
                                      sizeof( MENUITEMTEMPLATEHEADER ) +
                                      (6*sizeof( MENUITEMTEMPLATE )) +
                                      MAXMENUNAMES );


                  // Set values for MENUITEMTEMPLATEHEADER structure.
                  //.................................................
                  wValue = 0;
                  AppendMemory( lpMem, (LPTSTR)&wValue, sizeof( WORD ), 
                                TRUE, FALSE );
                  wValue = 0;
                  AppendMemory( lpMem, (LPTSTR)&wValue, sizeof( WORD ), 
                                FALSE, FALSE );

                  // Add Popup menu and items.
                  //..........................
                  wValue = MF_POPUP;
                  AppendMemory( lpMem, (LPTSTR)&wValue, sizeof( WORD ), 
                                FALSE, FALSE );
                  AppendMemory( lpMem, "&Popup", 7, FALSE, TRUE );

                  wValue = 0;
                  AppendMemory( lpMem, (LPTSTR)&wValue, sizeof( WORD ),
                                        FALSE, FALSE );
                  wValue = IDM_FIRST;
                  AppendMemory( lpMem, (LPTSTR)&wValue, sizeof( WORD ), 
                                        FALSE, FALSE );
                  AppendMemory( lpMem, "&First", 7, FALSE, TRUE );

                  wValue = MF_END;  // Last Item in Popup menu.
                  AppendMemory( lpMem, (LPTSTR)&wValue, sizeof( WORD ), 
                                        FALSE, FALSE );
                  wValue = IDM_SECOND;
                  AppendMemory( lpMem, (LPTSTR)&wValue, sizeof( WORD ), 
                                        FALSE, FALSE );
                  AppendMemory( lpMem, "&Second", 8, FALSE, TRUE );

                  // Add last item on menu bar, Exit.
                  //.................................
                  wValue = MF_END;
                  AppendMemory( lpMem, (LPTSTR)&wValue, sizeof( WORD ), 
                                        FALSE, FALSE );
                  wValue = IDM_EXIT;
                  AppendMemory( lpMem, (LPTSTR)&wValue, sizeof( WORD ), 
                                        FALSE, FALSE );
                  AppendMemory( lpMem, "E&xit", 6, FALSE, TRUE );

                  // Create the menu and set it as the applications menu.
                  //......................................................
                  hMenu = LoadMenuIndirect( lpMem );    
                  SetMenu( hWnd, hMenu );

                  HeapFree( GetProcessHeap(), 0, lpMem );
               }
               break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_FIRST :
                        MessageBox( hWnd, "First Menu Item Worked.", 
                                    "Message", MB_OK | MB_ICONINFORMATION );
                        break;

                 case IDM_SECOND :
                        MessageBox( hWnd, "Second Menu Item Worked.", 
                                    "Message", MB_OK | MB_ICONINFORMATION );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


VOID AppendMemory( LPTSTR lpDest, LPTSTR lpSource, int nBytes, BOOL bReset, 
                   BOOL bConvert )
{
static int   nLastEnd;
static WCHAR wBuf[30];

   LPTSTR lps, lpd;
   
   lps = lpSource;
   lpd = lpDest;

   if ( bReset )
      nLastEnd = 0;
   else
      lpd += nLastEnd;

   // If this is a character string, we need to convert it to Unicode(TM).
   // This is true for both Windows NT and Windows 95.
   //.....................................................................
   if ( bConvert )
   {
      MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, lpSource, -1, &wBuf[0], 30 );
       
      memcpy( lpd, &wBuf[0], nBytes*sizeof( WCHAR ) );
      nLastEnd += nBytes*sizeof( WCHAR );
   }
   else
   {
      memcpy( lpd, lps, nBytes );
      nLastEnd += nBytes;
   }
}


